## alex 2.0

=== Makefile ===
############################################################################
#
#			fptools/Makefile
#
#		This is the main Makefile for fptools.
#
############################################################################

TOP=.
include $(TOP)/mk/boilerplate.mk

# find the projects that actually exist...
ProjectsThatExist = $(filter $(patsubst %/, %, $(wildcard */)), $(AllProjects))

# and filter only those that the user requested, if necessary
ifeq "$(ProjectsToBuild)" ""
SUBDIRS = $(ProjectsThatExist)
else
SUBDIRS = $(filter $(ProjectsToBuild), $(ProjectsThatExist))
endif

ifneq "$(Project)" ""
   ifeq "$(Project)" "GreenCard"
       ProjectDirectory=green-card
   else
	ifeq "$(Project)" "HaskellDirect"
		ProjectDirectory=hdirect
	else
		ProjectDirectory=$(Project)
	endif
   endif
   include $(shell echo $(ProjectDirectory) | tr A-Z a-z)/mk/config.mk
endif

# -----------------------------------------------------------------------------
# Certain targets require that Project is set from the command line.

CURRENT_TARGET = $(MAKECMDGOALS)
project-check :
	@if [ "$(Project)" = "" ]; then \
		echo "	You need to set \"Project\" in order to make $(CURRENT_TARGET)"; \
		echo "	eg. make $(CURRENT_TARGET) Project=Ghc"; \
		exit 1; \
	fi

# -----------------------------------------------------------------------------
# Targets: all, stage1, stage2, stage3

DIST_CLEAN_FILES += config.cache config.status

#
# If you've ended up using an in-place version of Happy,
# make sure it gets built early on.
#
ifeq "$(HAPPY)" "$(FPTOOLS_TOP_ABS)/happy/src/happy-inplace"
build : $(FPTOOLS_TOP_ABS)/happy/src/happy-inplace

$(FPTOOLS_TOP_ABS)/happy/src/happy-inplace : glafp-utils
	$(MAKE) -C happy boot all
endif

# Build all projects that we know about
build :
	@case '${MFLAGS}' in *-[ik]*) x_on_err=0;; *-r*[ik]*) x_on_err=0;; *) x_on_err=1;; esac; \
	for i in $(SUBDIRS); do \
	   if [ -d $$i ]; then \
	      $(MAKE) -C $$i boot; \
	      if [ $$? -eq 0 -o $$x_on_err -eq 0 ] ;  then true; else exit 1; fi; \
	      $(MAKE) -C $$i all; \
	      if [ $$? -eq 0 -o $$x_on_err -eq 0 ] ;  then true; else exit 1; fi; \
	      fi; \
	done

ifeq "$(findstring ghc, $(SUBDIRS))" "ghc"

stage1 : build

stage2 :
	$(MAKE) -C ghc/compiler boot stage=2
	$(MAKE) -C ghc/compiler stage=2

stage3 :
	$(MAKE) -C ghc/compiler boot stage=3
	$(MAKE) -C ghc/compiler stage=3

bootstrap  : bootstrap2
bootstrap2 : stage1 stage2
bootstrap3 : stage1 stage2 stage3

all :: bootstrap

# We want to install the stage 2 bootstrapped compiler by default, but we let
# the user override this by saying 'make install stage=1', for example.
ifeq "$(stage)" ""
INSTALL_STAGE = stage=2
else
INSTALL_STAGE =
endif

else # Not building GHC

all :: build

INSTALL_STAGE =

endif

boot ::
	@echo "Please use \`make all' only from the top-level, or \`make boot' followed"
	@echo "by \`make all' in an individual project subdirectory (ghc, hslibs etc.)."

install ::
	@case '${MFLAGS}' in *-[ik]*) x_on_err=0;; *-r*[ik]*) x_on_err=0;; *) x_on_err=1;; esac; \
	for i in $(filter-out $(ProjectsDontInstall), $(SUBDIRS)); do \
	   if [ -d $$i ]; then \
	      $(MAKE) -C $$i $(INSTALL_STAGE) install; \
	      if [ $$? -eq 0 -o $$x_on_err -eq 0 ] ;  then true; else exit 1; fi; \
	      fi; \
	done

install-docs ::
	@case '${MFLAGS}' in *-[ik]*) x_on_err=0;; *-r*[ik]*) x_on_err=0;; *) x_on_err=1;; esac; \
	for i in $(filter-out $(ProjectsDontInstall), $(SUBDIRS)); do \
	   if [ -d $$i ]; then \
	      $(MAKE) -C $$i $(INSTALL_STAGE) install-docs; \
	      if [ $$? -eq 0 -o $$x_on_err -eq 0 ] ;  then true; else exit 1; fi; \
	      fi; \
	done

# -----------------------------------------------------------------------------
# Making a binary distribution
#
# To make a particular binary distribution: 
# set $(Project) to the name of the project, capitalised (eg. Ghc or Happy).

# `dist' `binary-dist'
#      Create a distribution tar file for this program. The tar file
#      should be set up so that the file names in the tar file start with
#      a subdirectory name which is the name of the package it is a
#      distribution for. This name can include the version number.
#
#      For example, the distribution tar file of GCC version 1.40 unpacks
#      into a subdirectory named `gcc-1.40'.
# 
#      The easiest way to do this is to create a subdirectory
#      appropriately named, use ln or cp to install the proper files in
#      it, and then tar that subdirectory.
# 
#      The dist target should explicitly depend on all non-source files
#      that are in the distribution, to make sure they are up to date in
#      the distribution. See Making Releases.
#
#	binary-dist is an FPtools addition for binary distributions
# 

binary-dist :: project-check

BIN_DIST_TMPDIR=$(FPTOOLS_TOP_ABS)
BIN_DIST_NAME=$(ProjectNameShort)-$(ProjectVersion)

#
# list of toplevel directories to include in binary distrib.
#
BIN_DIST_MAIN_DIR=$($(Project)MainDir)
BIN_DIST_DIRS=$($(Project)BinDistDirs)

binary-dist:: binary-dist-pre

BIN_DIST_TOP= distrib/Makefile-bin.in \
	      distrib/configure-bin.in \
	      distrib/INSTALL \
	      $(BIN_DIST_MAIN_DIR)/ANNOUNCE \
	      $(BIN_DIST_MAIN_DIR)/VERSION \
	      $(BIN_DIST_MAIN_DIR)/LICENSE \
	      $(BIN_DIST_MAIN_DIR)/README \
	      glafp-utils/mkdirhier/mkdirhier \
	      install-sh \
	      config.guess \
	      config.sub   \
	      aclocal.m4

#
# binary-dist creates a binary bundle, set BIN_DIST_NAME
# to package name and do `make binary-dist Project=<project-name>'
# (normally this just a thing you would do from the toplevel of fptools)
#
.PHONY: binary-dist-pre binary-dist binary-pack

BIN_DIST_NAME=$(ProjectNameShort)-$(ProjectVersion)
BIN_DIST_TMPDIR=$(FPTOOLS_TOP_ABS)

binary-dist-pre::
ifeq "$(BIN_DIST)" ""
	echo "WARNING: To run the binary-dist target, you need to set BIN_DIST=1 in your build.mk" && exit 1
endif
	-rm -rf $(BIN_DIST_TMPDIR)/$(BIN_DIST_NAME)
	-$(RM) $(BIN_DIST_TMPDIR)/$(BIN_DIST_NAME).tar.gz
	-echo "BIN_DIST_DIRS = $(BIN_DIST_DIRS)"
	@for i in $(BIN_DIST_DIRS); do 		 	 \
	  if test -d "$$i"; then 			 \
	   echo $(MKDIRHIER) $(BIN_DIST_TMPDIR)/$(BIN_DIST_NAME)/bin/$(TARGETPLATFORM); \
	   $(MKDIRHIER) $(BIN_DIST_TMPDIR)/$(BIN_DIST_NAME)/bin/$(TARGETPLATFORM); \
	   echo $(MKDIRHIER) $(BIN_DIST_TMPDIR)/$(BIN_DIST_NAME)/lib/$(TARGETPLATFORM); \
	   $(MKDIRHIER) $(BIN_DIST_TMPDIR)/$(BIN_DIST_NAME)/lib/$(TARGETPLATFORM); \
	   echo $(MKDIRHIER) $(BIN_DIST_TMPDIR)/$(BIN_DIST_NAME)/share; \
	   $(MKDIRHIER) $(BIN_DIST_TMPDIR)/$(BIN_DIST_NAME)/share; \
	   echo $(MAKE) -C $$i $(MFLAGS) $(INSTALL_STAGE) install \
		prefix=$(BIN_DIST_TMPDIR)/$(BIN_DIST_NAME) \
		exec_prefix=$(BIN_DIST_TMPDIR)/$(BIN_DIST_NAME) \
		bindir=$(BIN_DIST_TMPDIR)/$(BIN_DIST_NAME)/bin/$(TARGETPLATFORM) \
		libdir=$(BIN_DIST_TMPDIR)/$(BIN_DIST_NAME)/lib/$(TARGETPLATFORM) \
		libexecdir=$(BIN_DIST_TMPDIR)/$(BIN_DIST_NAME)/lib/$(TARGETPLATFORM) \
		datadir=$(BIN_DIST_TMPDIR)/$(BIN_DIST_NAME)/share; \
	   $(MAKE) -C $$i $(MFLAGS) $(INSTALL_STAGE) install \
		prefix=$(BIN_DIST_TMPDIR)/$(BIN_DIST_NAME) \
		exec_prefix=$(BIN_DIST_TMPDIR)/$(BIN_DIST_NAME) \
		bindir=$(BIN_DIST_TMPDIR)/$(BIN_DIST_NAME)/bin/$(TARGETPLATFORM) \
		libdir=$(BIN_DIST_TMPDIR)/$(BIN_DIST_NAME)/lib/$(TARGETPLATFORM) \
		libexecdir=$(BIN_DIST_TMPDIR)/$(BIN_DIST_NAME)/lib/$(TARGETPLATFORM) \
		datadir=$(BIN_DIST_TMPDIR)/$(BIN_DIST_NAME)/share; \
	  fi; \
	done

binary-dist::
	@for i in $(BIN_DIST_TOP); do \
	  if test -f "$$i"; then \
	     echo cp $$i $(BIN_DIST_TMPDIR)/$(BIN_DIST_NAME); \
	     cp $$i $(BIN_DIST_TMPDIR)/$(BIN_DIST_NAME); \
	  fi; \
	done;
	@echo "Configuring the Makefile for this project..."
	touch $(BIN_DIST_TMPDIR)/$(BIN_DIST_NAME)/Makefile.in
	echo "package = $(ProjectNameShort)" >> $(BIN_DIST_TMPDIR)/$(BIN_DIST_NAME)/Makefile.in
	echo "version = $(ProjectVersion)" >> $(BIN_DIST_TMPDIR)/$(BIN_DIST_NAME)/Makefile.in
	echo "PACKAGE_SH_SCRIPTS = $($(Project)BinDistShScripts)" >> $(BIN_DIST_TMPDIR)/$(BIN_DIST_NAME)/Makefile.in
	echo "PACKAGE_PRL_SCRIPTS = $($(Project)BinDistPrlScripts)" >> $(BIN_DIST_TMPDIR)/$(BIN_DIST_NAME)/Makefile.in
	echo "PACKAGE_LIB_PRL_SCRIPTS = $($(Project)BinDistLibPrlScripts)" >> $(BIN_DIST_TMPDIR)/$(BIN_DIST_NAME)/Makefile.in
	echo "PACKAGE_BINS = $($(Project)BinDistBins)" >> $(BIN_DIST_TMPDIR)/$(BIN_DIST_NAME)/Makefile.in
	echo "PACKAGE_LINKS = $($(Project)BinDistLinks)" >> $(BIN_DIST_TMPDIR)/$(BIN_DIST_NAME)/Makefile.in
	cat $(BIN_DIST_TMPDIR)/$(BIN_DIST_NAME)/Makefile-bin.in >> $(BIN_DIST_TMPDIR)/$(BIN_DIST_NAME)/Makefile.in
	@echo "Generating a shippable configure script.."
	$(MV) $(BIN_DIST_TMPDIR)/$(BIN_DIST_NAME)/configure-bin.in $(BIN_DIST_TMPDIR)/$(BIN_DIST_NAME)/configure.in 
	( cd $(BIN_DIST_TMPDIR)/$(BIN_DIST_NAME); autoconf )
	if test -x $(BIN_DIST_MAIN_DIR)/mk/post-install-script ; then \
		cp $(BIN_DIST_MAIN_DIR)/mk/post-install-script \
			$(BIN_DIST_TMPDIR)/$(BIN_DIST_NAME) ; \
	fi
	if test -x $(BIN_DIST_MAIN_DIR)/mk/post-inplace-script ; then \
		cp $(BIN_DIST_MAIN_DIR)/mk/post-inplace-script \
			$(BIN_DIST_TMPDIR)/$(BIN_DIST_NAME) ; \
	fi
#
# binary dist'ing the documentation.  
# Which documentation to build/install is hardcoded below.
#

BINDIST_DOC_WAYS = html ps
# BINDIST_DOC_WAYS =

binary-dist ::
	@for i in $(BIN_DIST_DIRS); do 		 	 	\
	  if test -d "$$i"; then 			 	\
	    $(MAKE) -C $$i $(MFLAGS) $(BINDIST_DOC_WAYS); 	\
	    echo $(MAKE) -C $$i $(MFLAGS) install-docs SGMLDocWays="$(BINDIST_DOC_WAYS)" \
		prefix=$(BIN_DIST_TMPDIR)/$(BIN_DIST_NAME) 	\
		exec_prefix=$(BIN_DIST_TMPDIR)/$(BIN_DIST_NAME) \
		bindir=$(BIN_DIST_TMPDIR)/$(BIN_DIST_NAME)/bin/$(TARGETPLATFORM) \
		libdir=$(BIN_DIST_TMPDIR)/$(BIN_DIST_NAME)/lib/$(TARGETPLATFORM) \
		libexecdir=$(BIN_DIST_TMPDIR)/$(BIN_DIST_NAME)/lib/$(TARGETPLATFORM) \
		datadir=$(BIN_DIST_TMPDIR)/$(BIN_DIST_NAME)/share; \
	    $(MAKE) -C $$i $(MFLAGS) install-docs SGMLDocWays="$(BINDIST_DOC_WAYS)" \
		prefix=$(BIN_DIST_TMPDIR)/$(BIN_DIST_NAME) 	\
		exec_prefix=$(BIN_DIST_TMPDIR)/$(BIN_DIST_NAME) \
		bindir=$(BIN_DIST_TMPDIR)/$(BIN_DIST_NAME)/bin/$(TARGETPLATFORM) \
		libdir=$(BIN_DIST_TMPDIR)/$(BIN_DIST_NAME)/lib/$(TARGETPLATFORM) \
		libexecdir=$(BIN_DIST_TMPDIR)/$(BIN_DIST_NAME)/lib/$(TARGETPLATFORM) \
		datadir=$(BIN_DIST_TMPDIR)/$(BIN_DIST_NAME)/share; \
	  fi \
	done

# Rename scripts to $i.prl and $i.sh where necessary.
# ToDo: do this in a cleaner way...

ifneq "$($(Project)BinDistPrlScripts)" ""
binary-dist::
	@for i in $($(Project)BinDistPrlScripts); do \
	     echo "Renaming $$i to $$i.prl"; \
	    $(MV) $(BIN_DIST_TMPDIR)/$(BIN_DIST_NAME)/bin/$(TARGETPLATFORM)/$$i  $(BIN_DIST_TMPDIR)/$(BIN_DIST_NAME)/bin/$(TARGETPLATFORM)/$$i.prl; \
	done
endif

ifneq "$($(Project)BinDistLibPrlScripts)" ""
binary-dist::
	@for i in $($(Project)BinDistLibPrlScripts); do \
	     echo "Renaming $$i to $$i.prl"; \
	    $(MV) $(BIN_DIST_TMPDIR)/$(BIN_DIST_NAME)/lib/$(TARGETPLATFORM)/$$i  $(BIN_DIST_TMPDIR)/$(BIN_DIST_NAME)/lib/$(TARGETPLATFORM)/$$i.prl; \
	done
endif

ifneq "$($(Project)BinDistShScripts)" ""
binary-dist::
	@for i in $($(Project)BinDistShScripts); do \
	     echo "Renaming $$i to $$i.sh"; \
	    $(MV) $(BIN_DIST_TMPDIR)/$(BIN_DIST_NAME)/bin/$(TARGETPLATFORM)/$$i  $(BIN_DIST_TMPDIR)/$(BIN_DIST_NAME)/bin/$(TARGETPLATFORM)/$$i.sh; \
	done
endif

#
# Do this separately for now
# 
binary-pack::
	( cd $(BIN_DIST_TMPDIR); $(TAR) chzf $(BIN_DIST_NAME).tar.gz $(BIN_DIST_NAME) )

ifneq "$(way)" ""
.PHONY: package-way-dist
package-way-dist::
	( cd $(BIN_DIST_TMPDIR); $(FIND) $(BIN_DIST_NAME)/ \( -name "*$(_way).a" -o -name "*.$(way_)hi" \) -print | xargs tar cvf $(BIN_DIST_TMPDIR)/ghc-$(ProjectVersion)-$(way)-$(TARGETPLATFORM).tar )
	gzip $(BIN_DIST_TMPDIR)/ghc-$(ProjectVersion)-$(way)-$(TARGETPLATFORM).tar
endif

ifneq "$(way)" ""
remove-way-dist::
	( cd $(BIN_DIST_TMPDIR); $(FIND) $(BIN_DIST_NAME)/ \( -name "*$(_way).a" -o -name "*.$(way_)hi" \) -print -exec $(RM) {} \; )
endif

binary-dist::

=== alex/Makefile ===
TOP = .
include $(TOP)/mk/boilerplate.mk

SUBDIRS = src templates doc

include $(TOP)/mk/target.mk

=== alex/doc/Makefile ===
TOP=../..
include $(TOP)/mk/boilerplate.mk

SGML_DOC = alex
INSTALL_SGML_DOC = alex

include $(TOP)/mk/target.mk

=== alex/src/Makefile ===
TOP = ..
include $(TOP)/mk/boilerplate.mk

INSTALLING=1

HS_PROG = alex.bin

Main_HC_OPTS = -DALEX_VERSION=$(ProjectVersion)

ifeq "$(INSTALLING)" "1"
ifeq "$(BIN_DIST)"   "1"
ALEXLIB=$$\"\"libdir
ALEXBIN=$$\"\"libexecdir/$(HS_PROG)
else
ALEXLIB=$(libdir)
ALEXBIN=$(libexecdir)/$(HS_PROG)
endif # BIN_DIST
else
ALEXLIB=$(FPTOOLS_TOP_ABS)/alex/templates
ALEXBIN=$(FPTOOLS_TOP_ABS)/alex/src/$(HS_PROG)
endif

INSTALLED_SCRIPT_PROG  = alex-$(ProjectVersion)
INPLACE_SCRIPT_PROG    = alex-inplace

ifeq "$(INSTALLING)" "1"
TOP_PWD 	:= $(prefix)
SCRIPT_PROG 	=  $(INSTALLED_SCRIPT_PROG)
LINK	 	=  alex
else
TOP_PWD 	:= $(FPTOOLS_TOP_ABS)
SCRIPT_PROG 	=  $(INPLACE_SCRIPT_PROG)
endif

SCRIPT_OBJS=alex.sh

INTERP=$(SHELL)

SCRIPT_SUBST_VARS = 	\
	ALEXLIB	\
	ALEXBIN

INSTALL_SCRIPTS += $(SCRIPT_PROG)
INSTALL_LIBEXECS = $(HS_PROG)

# don't recurse on 'make install'
#
ifeq "$(INSTALLING)" "1"
all clean distclean maintainer-clean ::
	$(MAKE) INSTALLING=0 BIN_DIST=0 $(MFLAGS) $@
endif

# -----------------------------------------------------------------------------
# Testing

cmp :: Scan.hs
	./alex-inplace Scan.x -o Scan.hs-CMP
	cmp Scan.hs Scan.hs-CMP

CLEAN_FILES += Scan.hs-CMP

# -----------------------------------------------------------------------------

include $(TOP)/mk/target.mk

=== alex/templates/Makefile ===
# -----------------------------------------------------------------------------
# $Id: Makefile,v 1.2 2003/08/08 15:43:58 simonmar Exp $

TOP = ..
include $(TOP)/mk/boilerplate.mk

TEMPLATES = \
	AlexTemplate \
	AlexTemplate-ghc \
	AlexTemplate-ghc-debug \
	AlexTemplate-debug \
	AlexWrapper-basic \
	AlexWrapper-posn \
	AlexWrapper-monad \
	AlexWrapper-gscan

GENERIC_TEMPLATE = GenericTemplate.hs

INSTALL_DATAS = $(TEMPLATES)

all :: $(TEMPLATES)

override datadir = $(libdir)

ghc_411_at_least = $(shell expr "$(GhcMajVersion)"  =   4 \& \
                                "$(GhcMinVersion)" \>= 11 \| \
                                "$(GhcMajVersion)" \>   4)

ifeq "$(ghc_411_at_least)" "1"
CPP_IT = $(GHC) -E -cpp -o
else
CPP_IT = $(GHC) -E -cpp >
endif

AlexTemplate.hspp : $(GENERIC_TEMPLATE)
	$(CPP_IT) $@ $(GENERIC_TEMPLATE)

AlexTemplate-ghc.hspp : $(GENERIC_TEMPLATE)
	$(CPP_IT) $@ -DALEX_GHC $(GENERIC_TEMPLATE)

AlexTemplate-ghc-debug.hspp : $(GENERIC_TEMPLATE)
	$(CPP_IT) $@ -DALEX_GHC -DALEX_DEBUG $(GENERIC_TEMPLATE)

AlexTemplate-debug.hspp : $(GENERIC_TEMPLATE)
	$(CPP_IT) $@ -DALEX_DEBUG $(GENERIC_TEMPLATE)

AlexTemplate-monad.hspp : $(GENERIC_TEMPLATE)
	$(CPP_IT) $@ -DALEX_MONAD $(GENERIC_TEMPLATE)

AlexWrapper-basic.hspp : wrappers.hs
	$(CPP_IT) $@ -DALEX_BASIC $<

AlexWrapper-posn.hspp : wrappers.hs
	$(CPP_IT) $@ -DALEX_POSN $<

AlexWrapper-monad.hspp : wrappers.hs
	$(CPP_IT) $@ -DALEX_MONAD $<

AlexWrapper-gscan.hspp : wrappers.hs
	$(CPP_IT) $@ -DALEX_GSCAN $<

# hack to turn cpp-style '# 27 "GenericTemplate.hs"' into 
# '{-# LINE 27 "GenericTemplate.hs" #-}'.
% : %.hspp
	perl -pe 's/^#\s+(\d+)\s+(\"[^\"]*\")/{-# LINE \1 \2 #-}/g;s/\$$(Id:.*)\$$/\1/g' < $< > $@

CLEAN_FILES += $(TEMPLATES) $(patsubst %, %.hspp, $(TEMPLATES))

include $(TOP)/mk/target.mk

=== alex/tests/Makefile ===
TOP = ..
include $(TOP)/mk/boilerplate.mk

.PRECIOUS: .hs .o .bin

TESTS = simple.x tokens.x tokens_posn.x tokens_gscan.x

ALEX=../src/alex-inplace

%.n.hs : %.x
	$(ALEX) $(TEST_ALEX_OPTS) $< -o $@

%.g.hs : %.x
	$(ALEX) $(TEST_ALEX_OPTS) -g $< -o $@

CLEAN_FILES += *.n.hs *.g.hs *.info *.hi *.bin

ALL_TEST_HS = $(shell echo $(TESTS) | sed -e 's/\([^\. ]*\)\.\(l\)\{0,1\}x/\1.n.hs \1.g.hs/g')

ALL_TESTS = $(patsubst %.hs, %.run, $(ALL_TEST_HS))

HC_OPTS += -fglasgow-exts -package lang

%.run : %.bin
	./$<

%.bin : %.o
	$(HC) $(HC_OPTS) $($*_LD_OPTS) $< -o $@

all :: $(ALL_TESTS)

include $(TOP)/mk/target.mk

=== docs/ffi-art/Makefile ===
TOP = ../..
include $(TOP)/mk/boilerplate.mk

SGML_DOC = ffi-art
INSTALL_SGML_DOC = ffi-art

include $(TOP)/mk/target.mk

=== glafp-utils/lndir/Makefile ===
TOP=..
include $(TOP)/mk/boilerplate.mk

C_SRCS=lndir.c
C_PROG=lndir

CLEAN_FILES += $(C_PROG)$(exeext) $(C_OBJS)
DESTDIR=$(INSTBINDIR)

include $(TOP)/mk/target.mk

# Win32: cygwin supports symlinks, so make sure we
#        don't feed in the mingw flags here. In other
#        words, lndir.exe is a cygwin-based app.
CC_OPTS := $(filter-out -mno-cygwin,$(CC_OPTS))

=== glafp-utils/ltx/Makefile ===
TOP=..
include $(TOP)/mk/boilerplate.mk

SCRIPT_PROG=ltx
SCRIPT_OBJS=ltx.prl
SCRIPT_SUBST_VARS=DEFAULT_TMPDIR CONTEXT_DIFF

INTERP=perl
DESTDIR=$(INSTSCRIPTDIR)
CLEAN_FILES += $(SCRIPT_PROG)

include $(TOP)/mk/target.mk

=== glafp-utils/mkdependC/Makefile ===
#
# Boilerplate Makefile for building perl script that
# needs some configured constants prepended to it.
#
TOP=..
include $(TOP)/mk/boilerplate.mk

boot :: all

SCRIPT_PROG=mkdependC
SCRIPT_OBJS=mkdependC.prl
#
# Prepend (perl) bindings for these Makefile variables
# when creating `mkdependC' (a more flexible way of doing msub).
#
SCRIPT_SUBST_VARS=DEFAULT_TMPDIR CPP BUILDPLATFORM

CLEAN_FILES += $(SCRIPT_PROG)
INTERP=perl

include $(TOP)/mk/target.mk

=== glafp-utils/mkdirhier/Makefile ===
#
#

TOP=..
include $(TOP)/mk/boilerplate.mk

SCRIPT_PROG=mkdirhier
SCRIPT_OBJS=mkdirhier.sh
INTERP=$(SHELL)
CLEAN_FILES += $(SCRIPT_PROG)

include $(TOP)/mk/target.mk

=== glafp-utils/nofib-analyse/Makefile ===
# -----------------------------------------------------------------------------
# $Id: Makefile,v 1.5 2002/03/14 17:10:14 simonmar Exp $
# (c) Simon Marlow 1999-2000

TOP=..
include $(TOP)/mk/boilerplate.mk

SRC_HC_OPTS    += -fglasgow-exts -package util -package data -package text -cpp
HS_PROG		= nofib-analyse

include $(TOP)/mk/target.mk

## alex 2.0.1

=== alex/doc/Makefile ===
TOP=..
include $(TOP)/mk/boilerplate.mk

XML_DOC = alex
INSTALL_XML_DOC = alex

include $(TOP)/mk/target.mk

=== alex/src/Makefile ===
--- 
+++ 
@@ -3,9 +3,33 @@
 
 INSTALLING=1
 
-HS_PROG = alex.bin
+ifeq "$(TARGETPLATFORM)" "i386-unknown-mingw32"
+HS_PROG_EXT = .exe
+else
+HS_PROG_EXT = .bin
+endif
 
-Main_HC_OPTS = -DALEX_VERSION=$(ProjectVersion)
+HS_PROG = alex$(HS_PROG_EXT)
+
+ifeq "$(Windows)" "YES"
+Main_HC_OPTS += -Dmingw32_HOST_OS=1
+endif
+
+# -----------------------------------------------------------------------------=
+# Create the Version.hs file
+
+VERSION_HS = Version.hs
+EXTRA_SRCS += $(VERSION_HS)
+
+boot :: $(VERSION_HS)
+
+Version.hs : $(TOP)/mk/version.mk
+	@$(RM) -f $(VERSION_HS)
+	@echo "Creating $(VERSION_HS) ... "
+	@echo "module Version where" >>$(VERSION_HS)
+	@echo "version = \"$(ProjectVersion)\"" >> $(VERSION_HS)
+
+# -----------------------------------------------------------------------------
 
 ifeq "$(INSTALLING)" "1"
 ifeq "$(BIN_DIST)"   "1"
@@ -26,7 +50,9 @@
 ifeq "$(INSTALLING)" "1"
 TOP_PWD 	:= $(prefix)
 SCRIPT_PROG 	=  $(INSTALLED_SCRIPT_PROG)
+ifneq "$(TARGETPLATFORM)" "i386-unknown-mingw32"
 LINK	 	=  alex
+endif
 else
 TOP_PWD 	:= $(FPTOOLS_TOP_ABS)
 SCRIPT_PROG 	=  $(INPLACE_SCRIPT_PROG)
@@ -40,8 +66,16 @@
 	ALEXLIB	\
 	ALEXBIN
 
+# The script isn't installed on Windows; we run the binary directly
+ifeq "$(Windows)" "NO"
 INSTALL_SCRIPTS += $(SCRIPT_PROG)
+endif
+
 INSTALL_LIBEXECS = $(HS_PROG)
+
+# Hack to avoid automatic cleaning machinery from cleaning Scan.hs
+#
+DERIVED_ALEX_SRCS = 
 
 # don't recurse on 'make install'
 #

## alex 2.1.0~rc1

=== examples/Makefile ===
TOP = ..
include $(TOP)/mk/boilerplate.mk

PROGS = lit Tokens Tokens_posn Tokens_gscan words words_posn words_monad \
	tiny haskell

lit : lit.hs
	$(HC) $(HC_OPTS) -o $@ $<

tiny : Tokens_posn.o tiny.o
	$(HC) $(HC_OPTS) -o $@ Tokens_posn.o tiny.o

Tokens_posn : Tokens_posn.hs
	$(HC) $(HC_OPTS) -o $@ $<

Tokens_gscan : Tokens_gscan.hs
	$(HC) $(HC_OPTS) -o $@ $<

words : words.hs
	$(HC) $(HC_OPTS) -o $@ $<

words_posn : words_posn.hs
	$(HC) $(HC_OPTS) -o $@ $<

words_monad : words_monad.hs
	$(HC) $(HC_OPTS) -o $@ $<

haskell : haskell.hs
	$(HC) $(HC_OPTS) -o $@ $<

include $(TOP)/mk/target.mk

=== tests/Makefile ===
TOP = ..
include $(TOP)/mk/boilerplate.mk

.PRECIOUS: .hs .o .exe .bin

ifeq "$(TARGETPLATFORM)" "i386-unknown-mingw32"
HS_PROG_EXT = .exe
else
HS_PROG_EXT = .bin
endif


TESTS = simple.x tokens.x tokens_posn.x tokens_gscan.x

ALEX=../src/alex-inplace

%.n.hs : %.x
	$(ALEX) $(TEST_ALEX_OPTS) $< -o $@

%.g.hs : %.x
	$(ALEX) $(TEST_ALEX_OPTS) -g $< -o $@

CLEAN_FILES += *.n.hs *.g.hs *.info *.hi *.bin *.exe

ALL_TEST_HS = $(shell echo $(TESTS) | sed -e 's/\([^\. ]*\)\.\(l\)\{0,1\}x/\1.n.hs \1.g.hs/g')

ALL_TESTS = $(patsubst %.hs, %.run, $(ALL_TEST_HS))

HC_OPTS += -fglasgow-exts -package lang

%.run : %$(HS_PROG_EXT)
	./$<

%$(HS_PROG_EXT) : %.o
	$(HC) $(HC_OPTS) $($*_LD_OPTS) $< -o $@

all :: $(ALL_TESTS)

include $(TOP)/mk/target.mk

## alex 2.3.3

=== debian/changelog ===
alex (2.3.3-1) unstable; urgency=low

  [ Erik de Castro Lopo ]
  * New upstream version.

  [ Joachim Breitner ]
  * Source format 3.0 (quilt)

 -- Erik de Castro Lopo <erikd@mega-nerd.com>  Wed, 31 Mar 2010 21:10:35 +1100

alex (2.3.2-1) unstable; urgency=low

  * New upstream version.

 -- Erik de Castro Lopo <erikd@mega-nerd.com>  Fri, 12 Mar 2010 20:25:20 +1100

alex (2.3.1-3) unstable; urgency=low

  * debian/control: Change Priority: to extra.
  * debian/watch: Use format that works for --download-current-version.
  * debian/watch: Add .tar.gz to downloaded filename.
  * debian/watch: Include package name in downloaded .tar.gz.
  * debian/watch: Remove spaces, since they're not allowed by uscan.
  * debian/control: Use Vcs-Browser: field.
  * debian/control: Bump Standards-Version: to 3.8.4, no changes needed.
  * debian/control: Bump version of Build-Depends: on haskell-devscripts
    to 0.7 and remove versioned Build-Depends: on ghc6.

 -- Marco Túlio Gontijo e Silva <marcot@debian.org>  Sun, 21 Feb 2010 09:30:03 -0300

alex (2.3.1-2) unstable; urgency=low

  * debian/control: Add forgotten build-deps on autoconf, alex and happy to
    resolve FTBFS (Closes: #551233)

 -- Iain Lane <laney@ubuntu.com>  Fri, 16 Oct 2009 20:45:30 +0100

alex (2.3.1-1) unstable; urgency=low

  * New upstream release (Closes: #530313)
  * Let watchfile point to hackage 
  * Adopt for the Debian Haskell Group and adjust packaging.

 -- Joachim Breitner <nomeata@debian.org>  Mon, 05 Oct 2009 17:22:19 +0200

alex (2.2-0.2) unstable; urgency=low

  * Non-maintainer upload.
  * Fix "FTBFS: Not in scope: `buildVerbose'", thanks to Matt Kraai for the
    patch (Closes: #516277)

 -- Joachim Breitner <nomeata@debian.org>  Wed, 18 Mar 2009 19:01:37 +0100

alex (2.2-0.1) unstable; urgency=low

  * Non-maintainer upload.
  * New upstream release (Closes: #464360)
    - Cabal 1.2 is now required. (Closes: #460388)
    - ByteString wrappers: use Alex to lex ByteStrings directly.
    - Fixes a spelling mistake. (Closes: #419671)
  * debian/control:
    - Added Homepage field.
    - Bump the build dependency on ghc6 to 6.8.2 as the packages needs
      Cabal 1.2 to build.
    - Bump the Standards-Version to 3.7.3. No changes needed.
  * debian/copyright:
    - Fix debian-copyright-file-uses-obsolete-national-encoding lintian
      warning.
    - Update debian/copyright file with info from upstream LICENSE file.
  * debian/get_version.hs: Updated for Cabal 1.2
  * debian/rules: 
    - Fix debian-rules-ignores-make-clean-error lintian warning.
    - Remove the LICENSE installed by ./setup copy
  * Add debian/watch file.

 -- Arjan Oosting <arjan@debian.org>  Sun, 27 Apr 2008 15:31:08 +0200

alex (2.1.0~rc1-1) unstable; urgency=low

  * New upstream (release candidate) version.
  * Removed alex/ prefixes from various paths in debian/rules.
  * doc/configure generated by autoconf is in the Debian diff.
  * Build using cabal:
    * Various debian/rules changes.
    * Create debian/get_version.hs for extracting the version from the cabal
      file.
    * Requires ghc6 >= 6.4.2.
    * No longer tries to detect platform. Closes: #332980, #340326.
  * Add 'XSLTPROC_OPTS = --nonet' to doc/config.mk.in.
  * Remove src/Parser.y and src/Scan.x before cleaning so the generated
    files don't get cleaned.
  * Set Standards-Version to 3.7.2 (no changes needed).

 -- Ian Lynagh (wibble) <igloo@debian.org>  Thu, 26 Oct 2006 17:28:46 +0000

alex (2.0.1-1) unstable; urgency=low

  * New upstream version.
  * Compiled against new libgmp3-dev.
  * Add build-deps on xsltproc, docbook-xml and docbook-xsl.
  * Remove ps from "$(MAKE) -C alex/doc ps html" in debian/rules as
    the ps docs don't build.
  * Only copy the HTML docs into the install directory as the other
    aren't built.
  * index.html is now built for us, so we don't need to symlink
    alex.html to it.

 -- Ian Lynagh (wibble) <igloo@debian.org>  Sun, 18 Sep 2005 20:11:47 +0000

alex (2.0-3) unstable; urgency=low

  * Added x86_64 Linux to configure{,.in}. Closes: #253167.
  * Remove unportable {,} syntax from debian/rules.
  * Delete alex/doc/alex.out in clean target.

 -- Ian Lynagh (wibble) <igloo@debian.org>  Thu, 15 Jul 2004 21:25:08 +0000

alex (2.0-2) unstable; urgency=low

  * Added s390, m68k, mips, hppa, arm and powerpc Linux to configure{,.in}

 -- Ian Lynagh (wibble) <igloo@debian.org>  Wed, 01 Oct 2003 12:31:01 +0000

alex (2.0-1) unstable; urgency=low

  * Initial release. Closes: #151044.
  * Changed configure{,.in} to not require flex.
  * Wrote manpage for alex(1).
  * Fix references to happy/parsers and version/verbose confusion in the docs.
  * Changed wrapper to use $@ and ${1+"$@"} rather than $*
  * When giving usage info, always use the name "alex" (otherwise
    alex.bin is given).
  * Add sparc case to configure{,.in}.

 -- Ian Lynagh (wibble) <igloo@debian.org>  Tue, 09 Sep 2003 15:14:27 +0000

=== debian/control ===
Source: alex
Section: haskell
Priority: extra
Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
Uploaders: Joachim Breitner <nomeata@debian.org>
Standards-Version: 3.8.4
Build-Depends: cdbs (>= 0.4.59), 
               haskell-devscripts (>= 0.7),
               debhelper (>= 7),
               ghc6,
               alex,
               happy,
               jade,
               docbook-utils,
               docbook-xsl,
               docbook-xml,
               xsltproc,
               autoconf
Homepage: http://www.haskell.org/alex/
Vcs-Darcs: http://darcs.debian.org/pkg-haskell/alex
Vcs-Browser: http://darcs.debian.org/cgi-bin/darcsweb.cgi?r=pkg-haskell/alex

Package: alex
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: lexical analyser generator for Haskell
 Alex is a tool for generating lexical analysers in Haskell, given a
 description of the tokens to be recognised in the form of regular
 expressions. It is similar to the tool lex or flex for C/C++.

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for alex
# This file is public domain software, originally written by Joey Hess. 
# Adapted for alex by Ian Lynagh.
# Largely rewritten for cdbs and hlibrary.mk by Joachim Breitner in 2009.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_BUILD_DEPENDENCIES = build-arch

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/hlibrary.mk

clean::
	[ ! -f doc/config.mk ] || $(MAKE) -C doc clean
	# Remove these so setup clean doesn't remove the generated files
	#rm -f src/Parser.y src/Scan.x
	
	rm -f debian/get_version.o debian/get_version.hi debian/get_version
	rm -f doc/alex.1
	# Hacks:
	rm -f doc/config.log doc/config.status doc/config.mk doc/configure


configure/alex::
	# doc/configure is not shipped, generate it
	cd doc && autoconf && rm -r autom4te.cache &&  ./configure --prefix=/usr

	# used in build to stick version into man page
	ghc6 --make debian/get_version.hs -o debian/get_version

build/alex:: build-ghc6-stamp
	$(MAKE) -C doc html
	sed -e "s#@LIBDIR@#/usr/lib/alex-`debian/get_version`#g" \
	    -e "s#@DOCDIR@#/usr/share/doc/alex#g" \
	    -e "s#@VERSION@#`debian/get_version`#g" \
	  doc/alex.1.in > doc/alex.1

install/alex:: debian/tmp-inst-ghc6
	dh_installdirs usr/share/doc/alex/html
	cp -a doc/alex/* `pwd`/debian/`dh_listpackages`/usr/share/doc/alex/html

## alex 2.3.5

=== tests/Makefile ===
ALEX=../dist/build/alex/alex
HC=ghc -Wall -fno-warn-unused-binds -fno-warn-missing-signatures -fno-warn-unused-matches -fno-warn-name-shadowing -fno-warn-unused-imports

.PRECIOUS: .hs .o .exe .bin

ifeq "$(TARGETPLATFORM)" "i386-unknown-mingw32"
HS_PROG_EXT = .exe
else
HS_PROG_EXT = .bin
endif

TESTS = simple.x tokens.x tokens_posn.x tokens_gscan.x tokens_bytestring.x

TEST_ALEX_OPTS = --template=..

%.n.hs : %.x
	$(ALEX) $(TEST_ALEX_OPTS) $< -o $@

%.g.hs : %.x
	$(ALEX) $(TEST_ALEX_OPTS) -g $< -o $@

%.o : %.hs
	$(HC) $(HC_OPTS) -c -o $@ $<

CLEAN_FILES += *.n.hs *.g.hs *.info *.hi *.bin *.exe

ALL_TEST_HS = $(shell echo $(TESTS) | sed -e 's/\([^\. ]*\)\.\(l\)\{0,1\}x/\1.n.hs \1.g.hs/g')

ALL_TESTS = $(patsubst %.hs, %.run, $(ALL_TEST_HS))

HC_OPTS += -package array  -package bytestring
#-fglasgow-exts

%.run : %$(HS_PROG_EXT)
	./$<

%$(HS_PROG_EXT) : %.o
	$(HC) $(HC_OPTS) $($*_LD_OPTS) $< -o $@

all :: $(ALL_TESTS)

=== debian/changelog ===
alex (2.3.5-3) unstable; urgency=low

  * Update fix-bang-pattern.diff patch to add LANGUAGE option BanPatterns to
    generated code (Closes: #635113).
  * debian/control: Standards version (no changes required).

 -- Erik de Castro Lopo <erikd@mega-nerd.com>  Sun, 24 Jul 2011 14:15:36 +1000

alex (2.3.5-2) unstable; urgency=low

  [ Erik de Castro Lopo ]
  * Fix generated haskell code so it doesn't fail with -Werror
    (Closes: #623067).

  [ Giovanni Mascellani ]
  * Team upload.

 -- Giovanni Mascellani <gio@debian.org>  Sun, 17 Apr 2011 10:56:54 +0200

alex (2.3.5-1) unstable; urgency=low

  [ Erik de Castro Lopo ]
  * New upstream.
  * Remove patches/00-fix-warnings-on-big-endian.diff (fixed upstream).

  [ Marco Silva ]
  * Use ghc instead of ghc6

  [ Joachim Breitner ]
  * New upstream release

 -- Joachim Breitner <nomeata@debian.org>  Tue, 29 Mar 2011 13:43:36 +0530

alex (2.3.3-2) experimental; urgency=low

  * Fix warnings in alex generated code on big endian systems (Closes: #594181).
  * debian/control: Bump Standards-Version: to 3.9.1, no changes needed.

 -- Erik de Castro Lopo <erikd@mega-nerd.com>  Sat, 30 Oct 2010 21:16:14 +1100

=== debian/control ===
--- 
+++ 
@@ -3,11 +3,11 @@
 Priority: extra
 Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
 Uploaders: Joachim Breitner <nomeata@debian.org>
-Standards-Version: 3.8.4
-Build-Depends: cdbs (>= 0.4.59), 
+Standards-Version: 3.9.2
+Build-Depends: cdbs (>= 0.4.59),
                haskell-devscripts (>= 0.7),
                debhelper (>= 7),
-               ghc6,
+               ghc,
                alex,
                happy,
                jade,

=== debian/rules ===
--- 
+++ 
@@ -28,16 +28,16 @@
 	cd doc && autoconf && rm -r autom4te.cache &&  ./configure --prefix=/usr
 
 	# used in build to stick version into man page
-	ghc6 --make debian/get_version.hs -o debian/get_version
+	ghc --make debian/get_version.hs -o debian/get_version
 
-build/alex:: build-ghc6-stamp
+build/alex:: build-ghc-stamp
 	$(MAKE) -C doc html
 	sed -e "s#@LIBDIR@#/usr/lib/alex-`debian/get_version`#g" \
 	    -e "s#@DOCDIR@#/usr/share/doc/alex#g" \
 	    -e "s#@VERSION@#`debian/get_version`#g" \
 	  doc/alex.1.in > doc/alex.1
 
-install/alex:: debian/tmp-inst-ghc6
+install/alex:: debian/tmp-inst-ghc
 	dh_installdirs usr/share/doc/alex/html
 	cp -a doc/alex/* `pwd`/debian/`dh_listpackages`/usr/share/doc/alex/html

## alex 3.0.1

=== tests/Makefile ===
--- 
+++ 
@@ -9,7 +9,7 @@
 HS_PROG_EXT = .bin
 endif
 
-TESTS = simple.x tokens.x tokens_posn.x tokens_gscan.x tokens_bytestring.x
+TESTS = unicode.x simple.x tokens.x tokens_posn.x tokens_gscan.x tokens_bytestring.x tokens_posn_bytestring.x tokens_strict_bytestring.x
 
 TEST_ALEX_OPTS = --template=..
 
@@ -28,13 +28,16 @@
 
 ALL_TESTS = $(patsubst %.hs, %.run, $(ALL_TEST_HS))
 
-HC_OPTS += -package array  -package bytestring
-#-fglasgow-exts
-
 %.run : %$(HS_PROG_EXT)
 	./$<
 
 %$(HS_PROG_EXT) : %.o
-	$(HC) $(HC_OPTS) $($*_LD_OPTS) $< -o $@
+	$(HC) $(HC_OPTS) -package array -package bytestring $($*_LD_OPTS) $< -o $@
 
 all :: $(ALL_TESTS)
+
+
+interact:
+	ghci -cpp -i../src -i../dist/build/autogen -i../dist/build/alex/alex-tmp Main -fbreak-on-exception 
+# -args='--template=.. simple.x -o simple.n.hs'
+# :set args --template=.. simple.x -o simple.n.hs

=== debian/changelog ===
alex (3.0.1-1) unstable; urgency=low

  * New upstream release.  closes: #638988.
  * Update fix-bang-pattern.diff.
  * Add build dependency on libghc-quickcheck2-dev.

 -- Clint Adams <clint@debian.org>  Tue, 23 Aug 2011 11:21:06 -0400

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: haskell
 Priority: extra
 Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
-Uploaders: Joachim Breitner <nomeata@debian.org>
+Uploaders: Joachim Breitner <nomeata@debian.org>, Clint Adams <clint@debian.org>
 Standards-Version: 3.9.2
 Build-Depends: cdbs (>= 0.4.59),
                haskell-devscripts (>= 0.7),
@@ -15,7 +15,8 @@
                docbook-xsl,
                docbook-xml,
                xsltproc,
-               autoconf
+               autoconf,
+               libghc-quickcheck2-dev
 Homepage: http://www.haskell.org/alex/
 Vcs-Darcs: http://darcs.debian.org/pkg-haskell/alex
 Vcs-Browser: http://darcs.debian.org/cgi-bin/darcsweb.cgi?r=pkg-haskell/alex

## alex 3.0.5

=== debian/changelog ===
alex (3.0.5-2) unstable; urgency=low

  * /usr/share/alex-3.0.5 -> /usr/share/alex
  * Bump version of Build-Depends: on haskell-devscripts

 -- Louis Bettens <louis@bettens.info>  Mon, 29 Jul 2013 18:50:09 +0200

alex (3.0.5-1) unstable; urgency=low

  [ Erik de Castro Lopo ]
  [Joachim Breitner]
  * New upstream release
  * Enable tests

  [Erik de Castro Lopo]
  * Drop patches/fix-bang-pattern.diff (not needed any longer)
  * Add patches/cabal-test.diff to make the tests compile

 -- Joachim Breitner <nomeata@debian.org>  Wed, 29 May 2013 23:51:42 +0200

alex (3.0.2-2) unstable; urgency=low

  * Enable compat level 9

 -- Joachim Breitner <nomeata@debian.org>  Fri, 24 May 2013 12:49:40 +0200

alex (3.0.2-1) experimental; urgency=low

  * Depend on haskell-devscripts 0.8.13 to ensure this packages is built
    against experimental
  * Bump standards version, no change
  * New upstream release

 -- Joachim Breitner <nomeata@debian.org>  Fri, 19 Oct 2012 23:11:20 +0200

## alex 3.1.0

=== examples/Makefile ===
ALEX=../dist/build/alex/alex
HC=ghc -Wall -fno-warn-unused-binds -fno-warn-missing-signatures -fno-warn-unused-matches -fno-warn-name-shadowing -fno-warn-unused-imports

HAPPY=happy
HAPPY_OPTS=-agc

ifeq "$(TARGETPLATFORM)" "i386-unknown-mingw32"
exeext=.exe
else
exeext=
endif

PROGS = lit Tokens Tokens_gscan words words_posn words_monad tiny haskell

ALEX_OPTS = --template=.. -g
# ALEX_OPTS = --template=..

%.hs : %.x
	$(ALEX) $(ALEX_OPTS) $< -o $@

%.hs : %.y
	$(HAPPY) $(HAPPY_OPTS) $< -o $@

%.o : %.hs
	$(HC) $(HC_OPTS) -c -o $@ $<

CLEAN_FILES += *.info *.hi *.o *.bin *.exe

all : $(addsuffix $(HS_PROG_EXT),$(PROGS))

tiny$(exeext) : tiny.hs Tokens_posn.hs
	$(HC) $(HC_OPTS) -o $@ $^

lit$(exeext) : lit.hs
	$(HC) $(HC_OPTS) -o $@ $^

Tokens$(exeext) : Tokens.hs
	$(HC) $(HC_OPTS) -o $@ $^

Tokens_gscan$(exeext) : Tokens_gscan.hs
	$(HC) $(HC_OPTS) -o $@ $^

words$(exeext) : words.hs
	$(HC) $(HC_OPTS) -o $@ $^

words_posn$(exeext) : words_posn.hs
	$(HC) $(HC_OPTS) -o $@ $^

words_monad$(exeext) : words_monad.hs
	$(HC) $(HC_OPTS) -o $@ $^

haskell$(exeext) : haskell.hs
	$(HC) $(HC_OPTS) -o $@ $^

.PHONY: clean
clean:
	rm -f *.o *.hi *.bin $(addsuffix $(exeext),$(PROGS)) \
		$(addsuffix .hs,$(PROGS)) Tokens_posn.hs

=== tests/Makefile ===
--- 
+++ 
@@ -1,7 +1,8 @@
 ALEX=../dist/build/alex/alex
-HC=ghc -Wall -fno-warn-unused-binds -fno-warn-missing-signatures -fno-warn-unused-matches -fno-warn-name-shadowing -fno-warn-unused-imports
+HC=ghc
+HC_OPTS=-Wall -fno-warn-unused-binds -fno-warn-missing-signatures -fno-warn-unused-matches -fno-warn-name-shadowing -fno-warn-unused-imports
 
-.PRECIOUS: .hs .o .exe .bin
+.PRECIOUS: %.n.hs %.g.hs %.o %.exe %.bin
 
 ifeq "$(TARGETPLATFORM)" "i386-unknown-mingw32"
 HS_PROG_EXT = .exe
@@ -22,7 +23,7 @@
 %.o : %.hs
 	$(HC) $(HC_OPTS) -c -o $@ $<
 
-CLEAN_FILES += *.n.hs *.g.hs *.info *.hi *.bin *.exe
+CLEAN_FILES += *.n.hs *.g.hs *.info *.hi *.o *.bin *.exe
 
 ALL_TEST_HS = $(shell echo $(TESTS) | sed -e 's/\([^\. ]*\)\.\(l\)\{0,1\}x/\1.n.hs \1.g.hs/g')
 
@@ -36,6 +37,9 @@
 
 all :: $(ALL_TESTS)
 
+.PHONY: clean
+clean:
+	rm -f $(CLEAN_FILES)
 
 interact:
 	ghci -cpp -i../src -i../dist/build/autogen -i../dist/build/alex/alex-tmp Main -fbreak-on-exception

=== debian/changelog ===
alex (3.1.0-1) unstable; urgency=low

  * New upstream release

 -- Joachim Breitner <nomeata@debian.org>  Wed, 18 Sep 2013 19:12:23 +0200

=== debian/control ===
--- 
+++ 
@@ -3,10 +3,11 @@
 Priority: extra
 Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
 Uploaders: Joachim Breitner <nomeata@debian.org>, Clint Adams <clint@debian.org>
-Standards-Version: 3.9.2
+         , Louis Bettens <louis@bettens.info>
+Standards-Version: 3.9.4
 Build-Depends: cdbs (>= 0.4.59),
-               haskell-devscripts (>= 0.7),
-               debhelper (>= 7),
+               haskell-devscripts (>= 0.8.19),
+               debhelper (>= 9),
                ghc,
                alex,
                happy,

=== debian/rules ===
--- 
+++ 
@@ -8,6 +8,8 @@
 #export DH_VERBOSE=1
 
 DEB_BUILD_DEPENDENCIES = build-arch
+
+DEB_ENABLE_TESTS = yes
 
 include /usr/share/cdbs/1/rules/debhelper.mk
 include /usr/share/cdbs/1/class/hlibrary.mk

=== debian/watch ===
version=3
opts="downloadurlmangle=s|archive/([\w\d_-]+)/([\d\.]+)/|archive/$1/$2/$1-$2.tar.gz|,\
filenamemangle=s|(.*)/$|alex-$1.tar.gz|" \
    http://hackage.haskell.org/packages/archive/alex \
    ([\d\.]*\d)/

## alex 3.1.3

=== debian/changelog ===
alex (3.1.3-1) unstable; urgency=low

  * Adjust watch file to new hackage layout
  * New upstream release

 -- Joachim Breitner <nomeata@debian.org>  Sun, 09 Mar 2014 11:13:50 +0100

=== debian/watch ===
version=3
http://hackage.haskell.org/package/alex/distro-monitor .*-([0-9\.]+).(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## alex 3.1.4

=== debian/changelog ===
alex (3.1.4-2) unstable; urgency=medium

  * Upload to unstable

 -- Joachim Breitner <nomeata@debian.org>  Mon, 27 Apr 2015 11:47:21 +0200

alex (3.1.4-1) experimental; urgency=medium

  * New upstream release

 -- Joachim Breitner <nomeata@debian.org>  Sun, 05 Apr 2015 16:29:13 +0200

alex (3.1.3-2) experimental; urgency=medium

  * Depend on haskell-devscripts 0.9, found in experimental

 -- Joachim Breitner <nomeata@debian.org>  Sat, 20 Dec 2014 17:09:19 +0100

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
          , Louis Bettens <louis@bettens.info>
 Standards-Version: 3.9.4
 Build-Depends: cdbs (>= 0.4.59),
-               haskell-devscripts (>= 0.8.19),
+               haskell-devscripts (>= 0.9),
                debhelper (>= 9),
                ghc,
                alex,

## alex 3.1.6

=== examples/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 ALEX=../dist/build/alex/alex
-HC=ghc -Wall -fno-warn-unused-binds -fno-warn-missing-signatures -fno-warn-unused-matches -fno-warn-name-shadowing -fno-warn-unused-imports
+HC=ghc -Wall -fno-warn-unused-binds -fno-warn-missing-signatures -fno-warn-unused-matches -fno-warn-name-shadowing -fno-warn-unused-imports -fno-warn-tabs
 
 HAPPY=happy
 HAPPY_OPTS=-agc
@@ -10,7 +10,7 @@
 exeext=
 endif
 
-PROGS = lit Tokens Tokens_gscan words words_posn words_monad tiny haskell
+PROGS = lit Tokens Tokens_gscan words words_posn words_monad tiny haskell tiger
 
 ALEX_OPTS = --template=.. -g
 # ALEX_OPTS = --template=..
@@ -52,6 +52,9 @@
 haskell$(exeext) : haskell.hs
 	$(HC) $(HC_OPTS) -o $@ $^
 
+tiger$(exeext) : tiger.hs
+	$(HC) $(HC_OPTS) -main-is TigerLexer -o $@ $^
+
 .PHONY: clean
 clean:
 	rm -f *.o *.hi *.bin $(addsuffix $(exeext),$(PROGS)) \

=== tests/Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 ALEX=../dist/build/alex/alex
 HC=ghc
-HC_OPTS=-Wall -fno-warn-unused-binds -fno-warn-missing-signatures -fno-warn-unused-matches -fno-warn-name-shadowing -fno-warn-unused-imports
+HC_OPTS=-Wall -fno-warn-unused-binds -fno-warn-missing-signatures -fno-warn-unused-matches -fno-warn-name-shadowing -fno-warn-unused-imports -fno-warn-tabs -Werror
 
 .PRECIOUS: %.n.hs %.g.hs %.o %.exe %.bin
 
@@ -10,7 +10,7 @@
 HS_PROG_EXT = .bin
 endif
 
-TESTS = unicode.x simple.x tokens.x tokens_posn.x tokens_gscan.x tokens_bytestring.x tokens_posn_bytestring.x tokens_strict_bytestring.x
+TESTS = unicode.x simple.x tokens.x tokens_posn.x tokens_gscan.x tokens_bytestring.x tokens_posn_bytestring.x tokens_strict_bytestring.x tokens_monad_bytestring.x tokens_monadUserState_bytestring.x null.x tokens_bytestring_unicode.x
 
 TEST_ALEX_OPTS = --template=..
 
@@ -19,9 +19,6 @@
 
 %.g.hs : %.x
 	$(ALEX) $(TEST_ALEX_OPTS) -g $< -o $@
-
-%.o : %.hs
-	$(HC) $(HC_OPTS) -c -o $@ $<
 
 CLEAN_FILES += *.n.hs *.g.hs *.info *.hi *.o *.bin *.exe
 
@@ -32,7 +29,7 @@
 %.run : %$(HS_PROG_EXT)
 	./$<
 
-%$(HS_PROG_EXT) : %.o
+%$(HS_PROG_EXT) : %.hs
 	$(HC) $(HC_OPTS) -package array -package bytestring $($*_LD_OPTS) $< -o $@
 
 all :: $(ALL_TESTS)

=== debian/changelog ===
alex (3.1.6-1) unstable; urgency=medium

  * New upstream release

 -- Clint Adams <clint@debian.org>  Mon, 11 Jan 2016 01:22:48 -0500

alex (3.1.5-2) unstable; urgency=medium

  * Implement a stage1 profile build for bootstrapping.

 -- Colin Watson <cjwatson@debian.org>  Tue, 22 Dec 2015 02:39:59 +0000

alex (3.1.5-1) unstable; urgency=medium

  * New upstream release

 -- Clint Adams <clint@debian.org>  Thu, 03 Dec 2015 23:39:07 -0500

alex (3.1.4-4) unstable; urgency=medium

  * Switch Vcs-Git/Vcs-Browser headers to new location.

 -- Clint Adams <clint@debian.org>  Thu, 03 Dec 2015 14:54:01 -0500

alex (3.1.4-3) experimental; urgency=medium

  * Add lintian override for spurious rpaths

 -- Joachim Breitner <nomeata@debian.org>  Thu, 20 Aug 2015 15:03:49 +0200

alex (3.1.4-2.1) experimental; urgency=medium

  [ Helmut Grohne ]
  * Mark alex as Multi-Arch:foreign.

  [ Joachim Breitner ]
  * Attempt to make debian/get_version.hs work with GHC-7.10
  * Bump standards-version to 3.9.6
  * Depend on haskell-devscripts >= 0.10 to ensure that this package
    builds against GHC in experimental

 -- Joachim Breitner <nomeata@debian.org>  Thu, 20 Aug 2015 10:26:51 +0200

=== debian/control ===
Source: alex
Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
Uploaders: Joachim Breitner <nomeata@debian.org>, Clint Adams <clint@debian.org>, Louis Bettens <louis@bettens.info>
Priority: extra
Section: haskell
Build-Depends: cdbs (>= 0.4.59),
 haskell-devscripts (>= 0.10),
 debhelper (>= 9.20141010),
 dpkg-dev (>= 1.17.14),
 ghc (>= 7.10),
 alex <!stage1>,
 happy,
 jade,
 docbook-utils,
 docbook-xsl,
 docbook-xml,
 xsltproc,
 autoconf,
 libghc-quickcheck2-dev,
Standards-Version: 3.9.6
Homepage: http://www.haskell.org/alex/
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-haskell/DHG_packages.git/
Vcs-Git: git://git.debian.org/git/pkg-haskell/DHG_packages.git

Package: alex
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends},
 ${misc:Depends},
Description: lexical analyser generator for Haskell
 Alex is a tool for generating lexical analysers in Haskell, given a
 description of the tokens to be recognised in the form of regular
 expressions. It is similar to the tool lex or flex for C/C++.

## alex 3.1.7

=== debian/changelog ===
alex (3.1.7-1) unstable; urgency=medium

  [ Dmitry Bogatov ]
  * Use secure (https) uri in Vcs-Git field in 'debian/control'
  * Bump standards version to 3.9.8 (no changes needed)

  [ Clint Adams ]
  * New upstream release

 -- Clint Adams <clint@debian.org>  Tue, 24 May 2016 22:10:48 -0400

alex (3.1.6-2) unstable; urgency=medium

  * Bump standards version to 3.9.8 (no changes needed)
  * Convert 'debian/copyright' to dep5 format

 -- Dmitry Bogatov <KAction@gnu.org>  Fri, 06 May 2016 18:20:00 +0300

=== debian/control ===
Source: alex
Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
Uploaders: Joachim Breitner <nomeata@debian.org>,
           Clint Adams <clint@debian.org>,
           Louis Bettens <louis@bettens.info>,
           Dmitry Bogatov <KAction@gnu.org>
Priority: extra
Section: haskell
Build-Depends: alex <!stage1>,
               autoconf,
               cdbs (>= 0.4.59),
               debhelper (>= 9.20141010),
               docbook-utils,
               docbook-xml,
               docbook-xsl,
               dpkg-dev (>= 1.17.14),
               ghc (>= 7.10),
               happy,
               haskell-devscripts (>= 0.10),
               jade,
               libghc-quickcheck2-dev,
               xsltproc
Standards-Version: 3.9.8
Homepage: http://www.haskell.org/alex/
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-haskell/DHG_packages.git/
Vcs-Git: https://anonscm.debian.org/cgit/pkg-haskell/DHG_packages.git

Package: alex
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: lexical analyser generator for Haskell
 Alex is a tool for generating lexical analysers in Haskell, given a
 description of the tokens to be recognised in the form of regular
 expressions. It is similar to the tool lex or flex for C/C++.
